%{ open Ast %}

%token PLUS MINUS TIMES DIVIDE
%token LPAREN RPAREN
%token EQUAL LESS GREATER 
%token IF
%token EOF
%token <int> LITERAL
%token <string> ID

%left PLUS MINUS
%left TIMES DIVIDE

%start expr
%type <Ast.expr> expr

%%

expr:
	LPAREN PLUS expr expr RPAREN 		{ Binop(Add, $3, $4) }
 |	LPAREN MINUS expr expr RPAREN		{ Binop(Sub, $3, $4) }
 |	LPAREN TIMES expr expr RPAREN		{ Binop(Mul, $3, $4) }
 |	LPAREN DIVIDE expr expr RPAREN		{ Binop(Div, $3, $4) }
 |	LPAREN EQUAL expr expr RPAREN		{ Binop(Equal, $3, $4) }
 |	LPAREN LESS expr expr RPAREN		{ Binop(Less, $3, $4) }
 |	LPAREN GREATER expr expr RPAREN		{ Binop(Greater, $3, $4) }

 |	LPAREN IF expr expr RPAREN			{ If($3, $4) }
 |	LPAREN IF expr expr expr RPAREN		{ IfElse($3, $4, $5) }
 |	LITERAL								{ Lit($1) }
 |	ID									{ Id($1) }


